/****************************************************************************
*                                                                          *
*               Copyright (c) 1996-97-98, Silicon Graphics, Inc.           *
*                                                                          *
*   Permission to use,  copy, modify, distribute, and sell this software   *
*   and its documentation for any purpose is hereby granted without fee,   *
*   provided that the name of  Silicon  Graphics  may not be used in any   *
*   advertising  or  publicity  relating  to  the  software  without the   *
*   specific, prior written permission of Silicon Graphics.                *
*                                                                          *
*   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
*   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
*   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
*                                                                          *
*   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
*   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
*   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
*   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
*   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
*   PERFORMANCE OF THIS SOFTWARE.                                          *
*                                                                          *
****************************************************************************/

#ifndef _DMUMOVIE_H
#define _DMUMOVIE_H

#include "dmuObj.h"

// <dmu> The dmuMovie acts as a base class for all the dmuMovie
// objects.  currently there is not much implemented in this class,
// and most methods are virtual.  Once more objects are implmented
// under dmuMovie, the commonalities between the objects will be
// extracted into dmuMovie.  This object just keeps a few member
// variables that will obviously fall into this category. </dmu>

class dmuMovie:public dmuObj {

public:

  // The constructor initializes member variables.
  dmuMovie();

  // The destructor performs norman dmuObj destruction. 
  virtual ~dmuMovie();


  // <dmu> 
  // <LI> <B>Virtual Methods</B> - The following methods are pure
  // virtuals and are implemented in classes that inherit from
  // dmuMovie <UL> 
  // </dmu>


  virtual int init(dmuParams *params = NULL);
  virtual int addSrcConstraints(DMparams *params);
  virtual int addDstConstraints(DMparams *params);
  virtual int start(int propagate = DMU_PROPAGATE);
  virtual int getFD();
  virtual int receive(DMbuffer inBuffer);
  virtual int handleEvents(fd_set fdSet);

protected:
  
  int movieStarted;
private:
};

#endif
